# ExtraEnemyCustomization (Version 1.x.x)
```
DISCLAIMER: This MOD is meant to be used by Rundown Developer to make their own enemy in ease. It's NOT a client-end MOD.
```
### [Use this Reference Config to learn how to use this MOD](https://github.com/GTFO-Modding/ExtraEnemyCustomization/raw/1.0-staging/wikifiles/EEC_1.0/ExtraEnemyCustomization.zip)  
### [Wiki Page (Very WIP at this moment)](https://github.com/Flowaria/ExtraEnemyCustomization/wiki) 
  
  
# Patch Note
 ### 1.0.0-alpha9
 - FINALLY👏FIXED👏SCANNERCUSTOM👏DESYNC👏BUG

 ### 1.0.0-alpha7
 - BehaviourAbility now can use AI.Target
 - Fixed Issue related to Ragdoll Position and Explosion
 - Fixed Issue related to Cultural problem with reading config

 ### 1.0.0-alpha6
 - Hopefully Fixed Desync issue with ScannerCustom
 - Bleeding now reset "bleeding" text on level cleanup
 - Fixed Issue related to RegenCustom (decay won't work as intended)
 - Fixed Issue related to DeathAbility (crash the game in few condition)
 - Fixed Issue related to MarkerCustom (missing icon on level reload)
 - ExplosionAbility now try to use Ragdoll position when agent already died
 - Added Color/Float setting to MaterialCustom

 ### 1.0.0-alpha5
 - Fixed Issue related to MaterialCustom

 ### 1.0.0-alpha4
 - Fixed Issue related to Reloading Config
 - Fixed Issue where MarkerCustom won't show custom ping icon images
 - Improved Material Caching
 - Added Config for Material Caching Result print method `Cached Asset Result Output` (default: None)

 ### 1.0.0-alpha3
 - Fixed issue related to BehaviourAbilityCustom
 - Added `KillInflictor`, `UseExplosionCounter`, `AllowedExplosionCount` to ExplosionAbility
 - Fixed Issue with ChainAbility was unusable
 - Added DoAnimAbility
 
 ### 1.0.0-alpha2
 - Added Bleeding effect visuals along with few more settings
 - Added AllowedMode setting to DeathAbility
 - Added Light effect to Explosion
 - Updated Reference Config file
 - Fixed Color Converter Issue
 - Fixed EnemyAbility without name handling
 - Fixed ScannerCustom Initial Color bug
 - Fixed issue that Explosion always do Full damage
 - Fixed issue related to PulseEffect and EnemyAbility

 ### 1.0.0-alpha1
 - Initial Release with alpha Testing
 - Now Support MTFO HotReloader Integration
 - Also Support LiveEdit (Default off)
 - Moved Few settings to `Global` Section, also including flyer stuck check
 - Added `EnemyAbility` Section! This allow you to work on your very own behaviour ability enemies!
 - Added `BoneCustom`
 - Added `ScoutScreamingCustom`
 - Added `ScoutAnimCustom`
 - Added SkinNoise settings to `MaterialCustom`
 - Color Converter Now can read multiplier (ie: `"Color": "red * 50.0"`
 - Updated `Bleed` related Settings
 - Updated `FogSphere Effect` related Settings



# Supported Features
 + ## Model Customization
    - `ShadowCustom`: Shadow Varient Customization (For every enemy model)
    - `MaterialCustom`: Material Swapper for changing skin of emenies
    - `GlowCustom`: for edting color of enemy glowing in general, also provide feature to adding custom Pulse Effect
    - `LimbCustom`: Enemy Limb Health/Weak/ArmorSpot Customization
    - `MarkerCustom`: Bio-tracker Ping Icon/Behaviour Customization (with custom images)
    - `ModelRefCustom`: ModelReference Custom for editing Bio-Tracker Ping position/Shooter Firing Position/Striker Tentacle Position
	 - `ScannerCustom`: Bio-tracker screen customization per enemies (with real-time color changes)
	 - `SilhouetteCustom`: Provides enemies silhouette to be able to see through the wall
    - `BoneCustom`: Powerful setting to change each enemy's bodypart scale/position/rotation

 + ## Ability Customization
    - `FogSphereCustom`: Fog Sphere Ability's Fog Setting
    - `BirthingCustom`: Birthing Ability Customization
    - `HealthRegenCustom`: for Health Regen/Decay Enemy
    - `InfectionAttackCustom`: for Infectious Tentacle/Punch
    - `ExplosiveAttackCustom`: for Explosive Tentacle/Punch
    - `KnockbackAttackCustom`: for adding knockback for Tentacle/Punch
    - `BleedAttackCustom`: for adding bleeding effect for Tentacle/Punch
    - `DoorBreakerCustom`: DoorBreaker Ability Speed/Damage Customization
    - `ScoutScreamingCustom`: Change Scout Screaming GlowColor and FogColor along with Infectious FogSphere

 + ## EnemyAbility Customization
    - `BehaviourAbilityCustom`: Trigger Ability based on Cooldown, Distance, LOS
    - `DeathAbilityCustom`: Trigger Ability when enemies death triggered

    * ### Supported Abilities
       - `FogSphere`
       - `Explosion`
       - `SpawnEnemy`
       - `EMP`
       - `Chain`: Trigger multiple ability

 + ## Striker Tentacle Customization
    - `StrikerTentacleCustom`
       - Striker Tentacle Model Type Customization
       - Striker Tentacle In/Out/Stay time Custom
    - `TentacleDefinitions`
       - Work in Progress

 + ## Shooter Firing Customization
    - `ShooterFireCustom`
       - Shooter Projectile Setting Custom
       - Distance based Projectile Setting Swapper
    - `ProjectileDefinitions`
       - Custom Shooter Projectile Editing
       - Explosive Projectile
       - Knockback Projectile
       - Bleeding Projectile
       - Infectious Projectile

 + ## Detection Customization
    - `FeelerCustom`: Scout Feeler Count/Color/Distance Customization
    - `ScoutAnimCustom`: Customizable Scout Feeler Animation

 + ## Scout Wave Customization
    - Different wave setting per Scout Variants
    - StopOnDead Setting for Scout alive orientated constant alarm
    - Random Picker for having different wave setting for single variant

 + ## SpawnCost Customization
    - You can edit Enemy's spawncost without editing population settings

 + ## Miscellaneous Things
    - Healer Enemies support: Negative Damage will now heal players
    - Global Config: Flyer Stuck Check

 + ## Partial Data Integration
    - You can use GUID to any enemy persistentID field if you using PartialData!


# Credits
 - peelz: Setup for future MTFO update
 - mccad00: Enemy Marker icons
 - Kasuromi: Providing codes related to SpawnCost / Helping me lot with PR review
 - Dex: Providing codes related to SilhouetteCustom
 - dakkhuza: Helping with implementing EMP / Providing codes related to Explosion